sep="#===SEP===#"
tmpdir=./

if test -d "devmap"
then
	devmapdir="devmap"
else
	devmapdir="/usr/share/openhw/devmap"
fi

devmap_script=$devmap_libdir/devmap.sh

# normalize sch given in $1 and print temp sch file name
# normalization is embedding components
norm_sch()
{
	tmp=`mktemp --suffix .sch`
	cat "$1" > $tmp
	gschlas -e $tmp
	echo $tmp
}


# read a normalized sch on stdin and print summary on stdout
summary()
{
	awk -v "libdir=$devmap_libdir" -v "tmpdir=$tmpdir" -v "devmap_script=$ME" -f $devmap_libdir/path.awk -f $devmap_libdir/gedaconf.awk -f $devmap_libdir/sch.awk -f $devmap_libdir/sch_list.awk -f $devmap_libdir/summary_out.awk -f $devmap_libdir/attr.awk
}

# read summary on stdin, apply devmap rules and write new summary to stdout
devmap()
{
	awk -v "libdir=$devmap_libdir" -v "devmapdir=$devmapdir" -f $devmap_libdir/summary_in.awk -f $devmap_libdir/summary_out.awk  -f $devmap_libdir/devmap.awk -f $devmap_libdir/attr.awk
}

# read summary on stdin and apply it on normalized sch $1, original sch name in $2
# printing to stdout
# if $3 is not empty, a list of recursively generated sch file names is appended to a file named $3
apply_summary()
{
	local basedir
	fn=$1
	basedir=`dirname $2`
	(
		cat
		echo "$sep"
		cat $1
	) | awk -v "sep=$sep" -v "dellist=$3" -v "libdir=$devmap_libdir" -v "tmpdir=$tmpdir" -v "basedir=$basedir" -v "devmap_script=$devmap_script" -f $devmap_libdir/path.awk -f $devmap_libdir/gedaconf.awk -f $devmap_libdir/schfilter.awk -f $devmap_libdir/sch.awk -f $devmap_libdir/attr.awk
}

# run the chain on sch $1, output to sch $2, $3 as for apply_summary
sch_devmap()
{
	local tmp
	tmp=`norm_sch $1`
	summary < $tmp | devmap | apply_summary $tmp $1 $3 > $2
	rm $tmp
}
